﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=6.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Private astream As AsyncStreams
	Private audioStream As AudioStreamer
	Private sendingAudio As Boolean
	Dim UDPSocket1 As UDPSocket
	Private const deviceIp As String = "192.168.0.255"
	Private const devicePort As Int = 51042
End Sub

Sub Service_Create
	UDPSocket1.Initialize("UDP",devicePort,8192) ' buffer data trasmessi / ricevuti
	audioStream.Initialize("AudioStream", 8000, True, 16, audioStream.VOLUME_MUSIC)
	audioStream.StartPlaying
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Public Sub Disconnect
		astream.Close
		AStream_Terminated
End Sub

Private Sub StartAStream (In As InputStream, out As OutputStream)
	Log("StartAStream")
	astream.Initialize(In,  out, "astream")
	' avvia StartPlaying per aver la ricezione pronta
	audioStream.StartPlaying
End Sub

Public Sub SendAudio
	audioStream.StartRecording
	sendingAudio = True
End Sub

Public Sub StopSendingAudio
	audioStream.StopRecording
	sendingAudio = False
End Sub

Sub AudioStream_RecordBuffer (data() As Byte)
	Dim Packet As UDPPacket
	ToastMessageShow("Dati in uscita " & data.Length, True)
	If sendingAudio =  True Then
		astream.Write(data)
		Packet.Initialize(data,deviceIp, devicePort) ' assegno un ip alla macchina che trasmette sulla posta
		UDPSocket1.Send(Packet)
	End If
End Sub

Sub astream_NewData (Buffer() As Byte)
	If sendingAudio = False Then ' se non è in trasmissione
		'esegue il buffer ricevuto per evitare lasern
		audioStream.Write(Buffer)
	End If
End Sub


Sub AStream_Terminated
	audioStream.StopPlaying
	audioStream.StopRecording
End Sub

Sub UDP_PacketArrived (Packet As UDPPacket)

	ToastMessageShow("Arrivano dati >" & Packet.Length , True)
	audioStream.Write(Packet.data)

End Sub